# -*- coding: utf-8 -*-

#1a) Una stringa può essere idealmente suddivisa in porzioni attigue ("frames" 
# o "slots") di ugual lunghezza ("frame_length"), a formare un "reading frame". 
# Si scriva una funzione in_what_frames(target, substring, frame_length=3) che, 
# considerando TUTTE le occorrenze di "substring" su "target" allineate 
# esattamente alla divisione in frame di lunghezza "frame_length", restituisca 
# una lista con i valori degli indici a cui iniziano tali occorrenze (ordinata 
# con valori crescenti).
# Tale funzione dovrà lanciare un'eccezione del tipo ValueError se la 
# lunghezza di "substring" non è un multiplo di "frame_length".
#
# Es: pappagallo="ara ararauna"
#     in_what_frames(pappagallo,'ar',2)   --> [0, 4, 6]
#     in_what_frames(pappagallo,'rar')    --> []
#     in_what_frames(pappagallo,'ara',3)  --> [0, 6]
#     in_what_frames(pappagallo,'ara',4)  --> ValueError

def in_what_frames(target, substring, frame_length=3):
    frame_length=int(frame_length)
    if len(substring)%frame_length:
        raise ValueError
    res=[]
    nextindex=0
    while True:
        nextindex=target.find(substring, nextindex)
        if nextindex>=0:
            borrow=nextindex%frame_length
            if not borrow: # this occurrence is aligned on the frame
                res.append(nextindex)
            nextindex=nextindex-borrow+frame_length # go ahead
        else:
            break     
    return res
    