# -*- coding: utf-8 -*-

#2a) Negli eucarioti, la sequenza di un gene tipicamente contiene esoni e 
# introni. Supponendo di conoscere le esatte sequenze degli esoni, nell'ordine 
# esatto, vorremmo riuscire a determinare la posizione di ciascuno di essi 
# all'interno della sequenza "target" da cui provengono. 
# Si scriva a tal proposito la funzione exon_positions(target, exon_list) che 
# restituisce la lista delle posizioni iniziali in "target" degli esoni in 
# "exon_list" (con indici che seguono le convenzione Python). Nel caso in cui 
# la soluzione non esista, si restituisca la lista vuota; nel caso in cui non 
# sia unica, si deve lanciare l'eccezione "ValueError".
# ATTENZIONE: inizio e fine degli esoni non sono necessariamente allineati sul
# reading frame.
#
# Es: t ="ATGATG    TCCA    TGAGA    ATGTAA" #-> 0,10,18,27
#     e=["ATGATG", "TCCA", "TGAGA", "ATGTAA"]
#     t1="ATGATGCCCCTCCACCCCTGAGACCCCATGTAA" #unique match
#     t2="ATGATGCCCCAACACCCCTGATTCCCCTTTTAA" #no match
#     t3="ATGATGTCCATCCAATGATGAGATCCAATGTAA" #multiple matches
#
#     exon_positions(t1,e)  --> [0, 10, 18, 27]
#     exon_positions(t2,e)  --> []
#     exon_positions(t3,e)  --> ValueError

from soluzione1 import in_what_frames

def exon_positions(target, exon_list):
    possible_exons_places=[]
    for exon in exon_list:
        exstarts=in_what_frames(target, exon, frame_length=1)
        if exstarts:
            possible_exons_places.append([[es, es+len(exon)] for es in exstarts])
        else:
            return [] #no match for this exon
        
    partial_sols=[[p] for p in possible_exons_places[0]]
    for curr_exon_places in possible_exons_places[1:]:
        next_partial_sols=[]
        for place in curr_exon_places:
            for psol in partial_sols:
                if psol[-1][1]<=place[0]:
                    in_sol=psol[:]
                    in_sol.append(place)
                    next_partial_sols.append(in_sol)
        if not next_partial_sols:
            return []
        partial_sols=next_partial_sols
    if len(partial_sols)>1:
        raise ValueError
    return [ e[0] for e in partial_sols[0]]
    
