# -*- coding: utf-8 -*-

#3a) Un esone può essere classificato in base al suo posizionamento rispetto 
# al reading frame del CDS a cui appartiene. La codifica di ciascuna delle nove
# possibili classi consiste in due interi, ciascuno con valore 0, 1 o 2; 
# p. es. (0,2). Tali numeri si riferiscono al primo nucleotide dell'esone, e al 
# nucleotide successivo all'ultimo; il loro valore corrispondone alla 
# differenza di posizione tra essi e la demarcazione di frame più vicina verso 
# l'inizio sequenza.
# Si scriva una funzione exon_class(orf, exon) che, data la sequenza di un 
# esone interno all'ORF (con posizionamento unico), restituisca una tupla 
# con i due interi corrispondenti alla sua classificazione.
# Nel caso in cui l'esone non compaia, si restituisca None; se compare in più 
# di una  posizione, si lanci ValueError.
#
# Es: n ="012012012012012012012012012012012"
#     t ="ATGATG    TCCA    TGAGA    ATGTAA" 
#     e=["ATGATG", "TCCA", "TGAGA", "ATGTAA"]
#     t1="ATGATGCCCCTCCACCCCTGAGACCCCATGTAA" #unique match
#     t2="ATGATGCCCCAACACCCCTGATTCCCCTTTTAA" #no match
#     t3="ATGATGTCCATCCAATGATGAGATCCAATGTAA" #multiple matches
#
#     exon_class(t1,e[1])  --> (1, 2)
#     exon_class(t2,e[1])  --> None
#     exon_class(t3,e[1])  --> ValueError

from soluzione1 import in_what_frames
          
def exon_class(orf, exon):
    positions=in_what_frames(orf, exon, frame_length=1)
    if not positions:
        return None
    if len(positions)>1:
        raise ValueError
    return (positions[0]%3, (positions[0]+len(exon))%3)

