# -*- coding: utf-8 -*-

#4a) Nella struttura secondaria dell'RNA, la forma più stabile di accoppiamento 
# tra basi è quella detta "canonica" o di Watson-Crick: A-U e C-G. Per ragioni 
# steriche, una base non può mai accoppiarsi con un'altra base che sia a lei 
# più vicina di "dist" posizioni sulla sequenza. 
# Si scriva la funzione pair_positions(rnaseq, dist=3) che, per ogni base di 
# rnaseq, individui le posizioni (in ordine crescente) delle basi a cui si 
# potrebbe accoppiare canonicamente, tenendo conto anche della distanza minima 
# "dist". Il risultato deve essere restituito sotto forma di lista il cui 
# elemento i-esimo corrisponde agli indici dei possibili accoppiamenti per la 
# i-esima base. 
#
# Es: r="AUGCUAAG"
#     pair_positions(r, dist=3) --> [[4], [5, 6], [], [7], [0], [1], [1], [3]]


def pair_positions(rnaseq, dist=3):
    comp={'A':'U', 'U':'A', 'C':'G', 'G':'C'}
    l=len(rnaseq)
    res=[[] for i in xrange(l)]
    for i, b in enumerate(rnaseq):
        for j in xrange(i+dist, l):
            if comp[b]==rnaseq[j]:
                res[i].append(j)
                res[j].append(i)
    return res
    
